#include "libcom.h"
#include "libthrd.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>

/** Constantes **/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024
#define MAX_UDP_MESSAGE 256

/** Variables publiques **/

/** Variables statiques **/

/** Procedure principale **/

int adresse=0;


void commandeHELO(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);	

}

void commandeMAIL(char *buffer, int s)
{

	char buffer_sortie[1024];
	char addr_expediteur[256];
    char *acc_ouvr,*acc_ferm;
    acc_ouvr=strchr(buffer,'<');
    acc_ferm=strchr(buffer,'>');
    int portee=acc_ferm-(acc_ouvr+1);
		                                         
    strncpy(addr_expediteur,(acc_ouvr+1),portee);
		                                         
	printf("Expediteur <%s>",addr_expediteur);
	sprintf(buffer_sortie, "250 OK expediteur enregistre\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
}

void commandeRCPT(char *buffer, int s)
{
	char buffer_sortie[1024];
    sprintf(buffer_sortie, "250 OK recipients memorises\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}

void commandeDATA(char *buffer,  int s)
{
	char buffer_sortie[1024];	                                 
	sprintf(buffer_sortie, "354 Continue, envoyez les donnees\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
}

void commande_traiter_DATA(char *buffer,  int s)
{
	//ENREGISTREMENT DES FICHIERS DE MESSAGE AINSI QUE LEUR STATUT
}

void commande_fin_DATA(char *buffer,  int s)
{
	char buffer_sortie[1024];	                                 
	sprintf(buffer_sortie, "250 OK Toutes les données sont recues\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	// FERMER FICHIERS ET SAUVEGARDER

}

void commandeQUIT(char *buffer,  int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "221 OK on se deconnecte\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	//close(s);
	//printf("Client déconnecté");

}


void commandeNOOP(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "220  Service Ready\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}

void commandeRSET(char *buffer, int s)
{
	// FAIRE DES MEMSET SUR LES VARIABLES				
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK on reset tout\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);

	printf("message du serveur:  %s", buffer_sortie);

}



void redirection_Commandes(char *buffer, int s)
{
	int commande_digit=4; // CONSTANTE
    char buffer_sortie[1024];
    if(strncmp(buffer,"EHLO",commande_digit)==0 || strncmp(buffer,"HELO",commande_digit)==0)
		 commandeHELO(buffer,s);
    else if(strncmp(buffer,"MAIL",commande_digit)==0)
		 commandeMAIL(buffer,s);
    else if(strncmp(buffer,"RCPT",commande_digit)==0)
		 commandeRCPT(buffer,s);
    else if(strncmp(buffer,"RSET",commande_digit)==0)
		 commandeNOOP(buffer,s);
    else if(strncmp(buffer,"QUIT",commande_digit)==0)
		commandeQUIT(buffer,s);
	    else 
		{
			sprintf(buffer_sortie, "502 La commande n'est pas implementee\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);
		};

}


void gestionClientTCP(int s)
{
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }

	int dans_message=0;
    	char buffer[1024], buffer_sortie[1024];
    
        sprintf(buffer_sortie, "220 localhost SMTP server \r\n");
    	printf("%s", buffer_sortie);
    	send(s, buffer_sortie, strlen(buffer_sortie), 0);

	    while(fgets(buffer,MAX_LIGNE,dialogue)!=NULL)
	    {
		printf("message du client: %s", buffer);
		//scanf("%s",&message_serveur);
		//fprintf(dialogue,"message du serveur:  %s",ligne);
		if(dans_message==0)
		{
				if(strncmp(buffer,"DATA",4)==0)
				{
						 commandeDATA(buffer,s);
						dans_message=1;
				}
				else
						redirection_Commandes(buffer,s);
		}
		if(dans_message==1)
		{
				if(strncmp(buffer,".\r\n",3)==0)
				{
						commande_fin_DATA(buffer,s);
						dans_message=0;
				}
				else
				{
						commande_traiter_DATA(buffer,s);
				}

	}

	    }
 
	/* Termine la connexion */
	fclose(dialogue);
	#if DEBUG
	printf("client déconnecté\n");
	#endif

}


int multi_gestionClientTCP(int s)
{
	lanceThread(gestionClientTCP,(int) s,0);
	return 0;
}




int main(int argc,char *argv[])
{	
	int s=0; // METTRE EN VARIABLE GLOBALE
	char *machine="localhost"; //127.0.0.1
	char *port_loopback="2525"; // car 25 nécessite root  // METTRE EN CONSTANTE
	char *port_local="4444"; // METTRE EN CONSTANTE

	/* Initialisation du serveur */
	s=initialisationServeurTCP(port_local);

	/* Lancement de la boucle d'ecoute */
	boucleServeurTCP(s,multi_gestionClientTCP);

	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);
}
